/*
	Copyright (C) 2011  Neil Munday (neil@mundayweb.com)

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

	A full copy of the terms of the GPL in the included text file "gpl.txt".
*/

function init(){

	var currentSetting = System.Gadget.Settings.read("userId");
	if (currentSetting != ""){
		userIdTxtbox.value = currentSetting;
	}

	currentSetting = System.Gadget.Settings.read("showProjects");
	if (currentSetting != ""){
		showProjectsTxtbox.value = currentSetting;
	}
	else{
		showProjectsTxtbox.value = 0;
	}

	currentSetting = System.Gadget.Settings.read("bgColour");
	if (currentSetting != ""){
		bgColourTxtbox.value = currentSetting;
	}
	else{
		bgColourTxtbox.value = defaultBgColour;
	}

	currentSetting = System.Gadget.Settings.read("txtColour");
	if (currentSetting != ""){
		txtColourTxtbox.value = currentSetting;
	}
	else{
		txtColourTxtbox.value = defaultTxtColour;
	}

	currentSetting = System.Gadget.Settings.read("borderColour");
	if (currentSetting != ""){
		borderColourTxtbox.value = currentSetting;
	}
	else{
		borderColourTxtbox.value = defaultBorderColour;
	}

	currentSetting = System.Gadget.Settings.read("showBorder");
	if (currentSetting !== ""){
		showBorderCheckbox.checked = currentSetting;
	}
	else{
		showBorderCheckbox.checked = defaultShowBorder;
	}

	borderColourTxtbox.disabled = !showBorderCheckbox.checked;

	currentSetting = System.Gadget.Settings.read("showDp");
	if (currentSetting !== ""){
		dpCheckbox.checked = currentSetting;
	}
	else{
		dpCheckbox.checked = defaultDp;
	}

	System.Gadget.onSettingsClosing = settingsClosing;
}

function settingsClosing(event){
	if (event.closeAction == event.Action.commit) {
		var value = parseInt(userIdTxtbox.value);
		if (!isNaN(value)){
			System.Gadget.Settings.write("userId", value);
		}

		value = parseInt(showProjectsTxtbox.value);
		if (!isNaN(value) && value >= 0){
			System.Gadget.Settings.write("showProjects", value);
		}

		System.Gadget.Settings.write("txtColour", txtColourTxtbox.value);
		System.Gadget.Settings.write("showBorder", showBorderCheckbox.checked);
		System.Gadget.Settings.write("borderColour", borderColourTxtbox.value);
		System.Gadget.Settings.write("bgColour", bgColourTxtbox.value);
		System.Gadget.Settings.write("showDp", dpCheckbox.checked);
	}
	event.cancel = false;
}

function enableBorderField(){
	borderColourTxtbox.disabled = !showBorderCheckbox.checked;
}